﻿--{{{ Libraries

local Aura = AceLibrary("SpecialEvents-Aura-2.0")
local L = AceLibrary("AceLocale-2.2"):new("GridStatusLifebloom")
local BS = AceLibrary("Babble-Spell-2.2")
local RL = AceLibrary("Roster-2.1")

--}}}
--
--{{{ Libraries

L:RegisterTranslations("enUS", function()
	return {
		["Lifebloom Stack"] = true,
		["Lifebloom Duration"] = true,

		["Color 1"] = true,
		["Color 2"] = true,
		["Color 3"] = true,
		["Color 4"] = true,
		["Color 5"] = true,
		["Color 6+"] = true,

		["Color when player has one heal-over-time buff"] = true,
		["Color when player has two heal-over-time buffs"] = true,
		["Color when player has three heal-over-time buffs"] = true,
		["Color when player has four heal-over-time buffs"] = true,
		["Color when player has five heal-over-time buffs"] = true,
		["Color when player has six or more heal-over-time buffs"] = true,
	}
end)

L:RegisterTranslations("koKR", function()
	return {
		["Lifebloom Stack"] = "다량 피어나는 생명",
		["Lifebloom Duration"] = "피어나는 생명 지속시간",

		["Color 1"] = "색상 1",
		["Color 2"] = "색상 2",
		["Color 3"] = "색상 3",
		["Color 4"] = "색상 4",
		["Color 5"] = "색상 5",
		["Color 6+"] = "색상 6+",

		["Color when player has one heal-over-time buff"] = "플레이어에게 1개의 강화 치유 지속 버프 색상",
		["Color when player has two heal-over-time buffs"] = "플레이어에게 2개의 강화 치유 지속 버프 색상",
		["Color when player has three heal-over-time buffs"] = "플레이어에게 3개의 강화 치유 지속 버프 색상",
		["Color when player has four heal-over-time buffs"] = "플레이어에게 4개의 강화 치유 지속 버프 색상",
		["Color when player has five heal-over-time buffs"] = "플레이어에게 5개의 강화 치유 지속 버프 색상",
		["Color when player has six or more heal-over-time buffs"] = "플레이어에게 1개 이상의 강화 치유 지속 버프 색상",
	}
end)

--}}}

GridStatusLifebloom = GridStatus:NewModule("GridStatusLifebloom")
GridStatusLifebloom.menuName = "Lifebloom Stack"
--GridStatusLifebloom.options = false

--{{{ AceDB defaults

GridStatusLifebloom.defaultDB = {
	debug = false,
	alert_LifebloomStack = {
		text = "Lifebloom Stack",
		enable = true,
		color = { r = 1, g = 0, b = 0, a = 1 },
		color2 = { r = 1, g = 1, b = 0, a = 1 },
		color3 = { r = 0, g = 1, b = 0, a = 1 },
		color4 = { r = 0, g = 1, b = 1, a = 1 },
		color5 = { r = 0, g = 0, b = 1, a = 1 },
		color6 = { r = 1, g = 0, b = 1, a = 1 },
		priority = 70,
		range = false,
	},
	alert_LifebloomDuration = {
		text = "Lifebloom Duration",
		enable = true,
		color = { r = 1, g = 0, b = 0, a = 1 },
		priority = 70,
		range = false,
	},
}

--}}}

--{{{ AceOptions table

local alert_LifebloomStackOptions = {
	["color2"] = {
		type = "color",
		name = L["Color 2"],
		desc = L["Color when player has two heal-over-time buffs"],
		hasAlpha = true,
		get = function ()
			local color = GridStatusLifebloom.db.profile.alert_LifebloomStack.color2
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusLifebloom.db.profile.alert_LifebloomStack.color2
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
	["color3"] = {
		type = "color",
		name = L["Color 3"],
		desc = L["Color when player has three heal-over-time buffs"],
		hasAlpha = true,
		get = function ()
			local color = GridStatusLifebloom.db.profile.alert_LifebloomStack.color3
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusLifebloom.db.profile.alert_LifebloomStack.color3
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
	["color4"] = {
		type = "color",
		name = L["Color 4"],
		desc = L["Color when player has four heal-over-time buffs"],
		hasAlpha = true,
		get = function ()
			local color = GridStatusLifebloom.db.profile.alert_LifebloomStack.color4
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusLifebloom.db.profile.alert_LifebloomStack.color4
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
	["color5"] = {
		type = "color",
		name = L["Color 5"],
		desc = L["Color when player has five heal-over-time buffs"],
		hasAlpha = true,
		get = function ()
			local color = GridStatusLifebloom.db.profile.alert_LifebloomStack.color5
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusLifebloom.db.profile.alert_LifebloomStack.color5
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
	["color6"] = {
		type = "color",
		name = L["Color 6+"],
		desc = L["Color when player has six or more heal-over-time buffs"],
		hasAlpha = true,
		get = function ()
			local color = GridStatusLifebloom.db.profile.alert_LifebloomStack.color6
			return color.r, color.g, color.b, color.a
		end,
		set = function (r, g, b, a)
			local color = GridStatusLifebloom.db.profile.alert_LifebloomStack.color6
			color.r = r
			color.g = g
			color.b = b
			color.a = a or 1
		end,
	},
}
function GridStatusLifebloom:OnInitialize()
	self.super.OnInitialize(self)
	self:RegisterStatus('alert_LifebloomStack', "Lifebloom Stack", alert_LifebloomStackOptions)
	self:RegisterStatus('alert_LifebloomDuration', "Lifebloom Duration", nil)
end


function GridStatusLifebloom:OnEnable()
	local f = function()
		GridStatusLifebloom:UpdateAllUnits("player")
	end
	self:RegisterEvent("SpecialEvents_UnitBuffGained")
	self:RegisterEvent("SpecialEvents_UnitBuffLost")
	self:RegisterEvent("SpecialEvents_UnitBuffCountChanged")
	self:RegisterEvent("Grid_UnitJoined")
	self:RegisterEvent("Grid_UnitDeath")
	self:RegisterEvent("PLAYER_ENTERING_WORLD", "UpdateAllUnits")
	self:ScheduleRepeatingEvent("GridLifebloom_Refresh", f, 0.1)
end


function GridStatusLifebloom:Reset()
	self.super.Reset(self)
	self:UpdateAllUnits()
end


function GridStatusLifebloom:UpdateAllUnits()
	local name, status, statusTbl

	for name, status, statusTbl in self.core:CachedStatusIterator("alert_LifebloomStack") do
		self:UpdateUnit(name,true)

--		for u in RL:IterateRoster() do
--			if name == UnitName(u.unitid) then
--				self:UpdateUnit(u.unitid,true)
--			end
--		end
	end
end


function GridStatusLifebloom:Grid_UnitJoined(name, unitid)
	if unitid then
		self:UpdateUnit(unitid)
	end
end


function GridStatusLifebloom:Grid_UnitDeath(unitname)
	local status, moduleName, desc
	for status, moduleName, desc in self.core:RegisteredStatusIterator() do
		if moduleName == self.name then
			self.core:SendStatusLost(unitname, status)
		end
	end
end

-- NOTE: Use Babble spell here below instead for localization

function GridStatusLifebloom:IsHOT( buff )
	if not buff then return false end
	return buff == BS["Lifebloom"]
end


function GridStatusLifebloom:CountHOTs(unitid)
	local maxbuffs = 40
	if unitid then
		for i = 1, maxbuffs do
			buffName, rank, texture, applications, duration, timeleft = UnitBuff(unitid,i,true)
			if buffName and timeleft then
				if self:IsHOT( buffName ) then
					return applications, timeleft
				end
			end
		end
	end
	return 0,0
end


function GridStatusLifebloom:SpecialEvents_UnitBuffGained(unit, buff, index, apps, tex, rank)
	self:UpdateUnit(unit,true)
	self:Debug("UnitBuffGained:"..buff)
	if self:IsHOT( buff ) then
		self:UpdateUnit(unit, true)
	end
end


function GridStatusLifebloom:SpecialEvents_UnitBuffLost(unit, buff, index, apps, tex, rank)
	self:Debug("UnitBuffLost:"..buff)
	if self:IsHOT( buff ) then
		self:UpdateUnit(unit, true)
	end
end

function GridStatusLifebloom:SpecialEvents_UnitBuffCountChanged(unit, buff, index, apps, tex, rank)
	self:Debug("UnitBuffChanged:"..buff)
	if self:IsHOT( buff ) then
		self:UpdateUnit(unit, true)
	end
end


function GridStatusLifebloom:UpdateUnit(unitid, ignoreRange)
	local name = UnitName(unitid)

	if not name then return end

	local settings = self.db.profile.alert_LifebloomStack
	local durationSettings = self.db.profile.alert_LifebloomDuration
	local LifebloomCount,lifebloomDuration = self:CountHOTs(unitid)

	self:Debug("Count:"..LifebloomCount)
	if LifebloomCount == 0 then
		self.core:SendStatusLost(name, "alert_LifebloomStack")
		self.core:SendStatusLost(name, "alert_LifebloomDuration")
	else
		local thecolor = settings.color
--		if LifebloomCount == 1 then
--			thecolor = settings.color
		if LifebloomCount == 2 then
			thecolor = settings.color2
		elseif LifebloomCount == 3 then
			thecolor = settings.color3
		end
		self.core:SendStatusGained(name, "alert_LifebloomDuration",
			settings.priority,
			(settings.range and 40),
			thecolor,
			string.format("%.1f", lifebloomDuration),
			lifebloomDuration,
			6 )

		self.core:SendStatusGained(name, "alert_LifebloomStack",
			settings.priority,
			(settings.range and 40),
			thecolor,
			tostring(LifebloomCount),
			LifebloomCount,
			6 )

	end
end
